#
# Conditional build:
%bcond_without	java	# Java JNI interface
%bcond_without	szip	# build without SZIP support
#
Summary:	Hierarchical Data Format library
Summary(pl.UTF-8):	Biblioteka HDF (Hierarchical Data Format)
Name:		hdf
Version:	4.2.15
Release:	1
Epoch:		1
Group:		Libraries
License:	Nearly BSD, but changed sources must be marked
Source0:	https://support.hdfgroup.org/ftp/HDF/releases/HDF%{version}/src/hdf-%{version}.tar.bz2
# Source0-md5:	27ab87b22c31906883a0bfaebced97cb
Source1:	http://www.mif.pg.gda.pl/homepages/ankry/man-PLD/%{name}-man-pages.tar.bz2
# Source1-md5:	607df78cacc131b37dfdb443e61e789a
Patch0:		%{name}-shared.patch
Patch1:		%{name}-morearchs.patch
Patch2:		%{name}-link.patch
Patch3:		%{name}-szip.patch
Patch4:		%{name}-tirpc.patch
Patch5:		%{name}-opt.patch
URL:		http://portal.hdfgroup.org/display/HDF4/HDF4
BuildRequires:	autoconf >= 2.50
BuildRequires:	automake
BuildRequires:	bison
BuildRequires:	flex
BuildRequires:	gcc-fortran
BuildRequires:	groff
%{?with_java:BuildRequires:	jdk}
BuildRequires:	libjpeg-devel >= 6b
BuildRequires:	libtirpc-devel
BuildRequires:	libtool >= 2:1.4d-3
BuildRequires:	rpmbuild(macros) >= 1.750
%{?with_szip:BuildRequires:	szip-devel >= 2.0}
BuildRequires:	which
BuildRequires:	zlib-devel >= 1.1.4
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
HDF is a multi-object file format that facilitates the transfer of
various types of scientific data between machines and operating
systems. Machines currently supported include the Cray, HP, Vax, Sun,
IBM RS/6000, Silicon Graphics, Macintosh, and IBM PC computers. HDF
allows self-definitions of data content and easy extensibility for
future enhancements or compatibility with other standard formats. HDF
includes Fortran and C calling interfaces,and utilities to prepare raw
image of data files or for use with other NCSA software. The HDF
library contains interfaces for storing and retrieving compressed or
uncompressed 8-bit and 24-bit raster images with palettes,
n-Dimensional scientific datasets and binary tables. An interface is
also included that allows arbitray grouping of other HDF objects.

%description -l pl.UTF-8
HDF jest wieloobiektowym formatem plików ułatwiającym przenoszenie
różnych danych naukowych pomiędzy różnymi komputerami i systemami
operacyjnymi. Aktualnie obsługiwane są m.in. Cray, HP, Vax, Sun, IBM
RS/6000, Silicon Graphics, Macintosh i IBM PC. HDF zawiera interfejsy
do Fortranu i C oraz narzędzia do przygotowywania plików z danymi.
Biblioteka pozwala na przechowywanie i odczytywanie skompresowanych
lub nie 8-bitowych i 24-bitowych obrazków z paletą, wielowymiarowych
zestawów danych itp.

%package devel
Summary:	HDF library development package
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki HDF
Group:		Development/Libraries
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	libjpeg-devel >= 6b
Requires:	libtirpc-devel
%{?with_szip:Requires:	szip-devel >= 2.0}
Requires:	zlib-devel >= 1.1.4

%description devel
Header files for HDF library.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki HDF.

%package static
Summary:	HDF static library
Summary(pl.UTF-8):	Statyczna biblioteka HDF
Group:		Development/Libraries
Requires:	%{name}-devel = %{epoch}:%{version}-%{release}

%description static
Static version of HDF library.

%description static -l pl.UTF-8
Statyczna wersja biblioteki HDF.

%package progs
Summary:	HDF utilities
Summary(pl.UTF-8):	Narzędzia do plików HDF
Group:		Applications/File
Requires:	%{name} = %{epoch}:%{version}-%{release}

%description progs
Utilities to convert from/to HDF format.

%description progs -l pl.UTF-8
Narzędzia do konwersji z i do formatu HDF.

%package examples
Summary:	HDF example programs (source code)
Summary(pl.UTF-8):	Przykładowe programy dla biblioteki HDF (w postaci źródłowej)
Group:		Documentation

%description examples
HDF example programs (source code).

%description examples -l pl.UTF-8
Przykładowe programy dla biblioteki HDF (w postaci źródłowej).

%package -n java-hdf
Summary:	Java HDF Interface (JHI)
Summary(pl.UTF-8):	Interfejs HDF do Javy (JHI)
Group:		Libraries/Java
URL:		http://portal.hdfgroup.org/display/HDFVIEW/JHI+Design+Notes
Requires:	java-slf4j >= 1.7.25

%description -n java-hdf
The Java Native Interface to the standard HDF library.

%description -n java-hdf -l pl.UTF-8
Natywny interfejs Javy (JNI) do biblioteki standardowej HDF.

%package -n java-hdf-javadoc
Summary:	Javadoc documentation for Java HDF Interface (JHI)
Summary(pl.UTF-8):	Dokumentacja javadoc do interfejsu HDF do Javy (JHI)
Group:		Documentation
URL:		http://portal.hdfgroup.org/display/HDFVIEW/JHI+Design+Notes

%description -n java-hdf-javadoc
Javadoc documentation for Java HDF Interface (JHI).

%description -n java-hdf-javadoc -l pl.UTF-8
Dokumentacja javadoc do interfejsu HDF do Javy (JHI).

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1

%build
%{__libtoolize}
%{__aclocal}
%{__autoconf}
%{__autoheader}
%{__automake}
# need to pass F77 to override F77=g77 in config/linux-gnu
%ifarch x32
%define	gfortran	x86_64-pld-linux-gnux32-gfortran
%else
%define	gfortran	%{_target_cpu}-pld-linux-gfortran
%endif
%define	gfortran_version	%(%{gfortran} -dumpversion)
%configure \
	F77="%{gfortran}" \
%if "%{_ver_ge '%{gfortran_version}' '10.0'}" == "1"
	FFLAGS="%{rpmcflags} -fallow-argument-mismatch" \
%endif
	%{?with_java:--enable-java} \
	--enable-shared \
	%{?with_szip:--with-szlib}

%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_mandir}/man{3,7},%{_includedir}/hdf}

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT \
	EXAMPLETOPDIR=$RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version} \
	EXAMPLEDIR=$RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}/c \
	hdf_javadir=%{_javadir}

%{__mv} $RPM_BUILD_ROOT%{_includedir}/*.{h,inc,f90} $RPM_BUILD_ROOT%{_includedir}/hdf

cp -p man/gr_chunk.3 $RPM_BUILD_ROOT%{_mandir}/man3
%{__mv} $RPM_BUILD_ROOT%{_mandir}/man1/hdf.1 $RPM_BUILD_ROOT%{_mandir}/man7/hdf.7

# resolve conflict with netcdf
for i in ncdump ncgen ; do
	%{__mv} $RPM_BUILD_ROOT%{_bindir}/$i $RPM_BUILD_ROOT%{_bindir}/hdf$i
	%{__mv} $RPM_BUILD_ROOT%{_mandir}/man1/$i.1 $RPM_BUILD_ROOT%{_mandir}/man1/hdf$i.1
done

%if %{with java}
%{__rm} $RPM_BUILD_ROOT%{_libdir}/libhdf_java.{la,a}
ln -sf jarhdf-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/jarhdf.jar
install -d $RPM_BUILD_ROOT%{_javadocdir}
cp -pr java/src/javadoc $RPM_BUILD_ROOT%{_javadocdir}/hdflib
%endif

bzip2 -dc %{SOURCE1} | tar xf - -C $RPM_BUILD_ROOT%{_mandir}
%{__rm} $RPM_BUILD_ROOT%{_mandir}/README.hdf-man-pages
%{__rm} $RPM_BUILD_ROOT%{_mandir}/diff.*

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%post	-n java-hdf -p /sbin/ldconfig
%postun	-n java-hdf -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc COPYING README.txt release_notes/{HISTORY,RELEASE,bugs_fixed,misc_docs}.txt
%attr(755,root,root) %{_libdir}/libdf.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libdf.so.0
%attr(755,root,root) %{_libdir}/libmfhdf.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libmfhdf.so.0
%{_libdir}/libhdf4.settings

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libdf.so
%attr(755,root,root) %{_libdir}/libmfhdf.so
%{_libdir}/libdf.la
%{_libdir}/libmfhdf.la
%{_includedir}/hdf
%{_mandir}/man3/gr_chunk.3*
%{_mandir}/man7/hdf.7*

%files static
%defattr(644,root,root,755)
%{_libdir}/libdf.a
%{_libdir}/libmfhdf.a

%files progs
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/gif2hdf
%attr(755,root,root) %{_bindir}/h4cc
%attr(755,root,root) %{_bindir}/h4fc
%attr(755,root,root) %{_bindir}/h4redeploy
%attr(755,root,root) %{_bindir}/hdf24to8
%attr(755,root,root) %{_bindir}/hdf2gif
%attr(755,root,root) %{_bindir}/hdf2jpeg
%attr(755,root,root) %{_bindir}/hdf8to24
%attr(755,root,root) %{_bindir}/hdfcomp
%attr(755,root,root) %{_bindir}/hdfed
%attr(755,root,root) %{_bindir}/hdfimport
%attr(755,root,root) %{_bindir}/hdfls
%attr(755,root,root) %{_bindir}/hdfncdump
%attr(755,root,root) %{_bindir}/hdfncgen
%attr(755,root,root) %{_bindir}/hdfpack
%attr(755,root,root) %{_bindir}/hdftopal
%attr(755,root,root) %{_bindir}/hdftor8
%attr(755,root,root) %{_bindir}/hdfunpac
%attr(755,root,root) %{_bindir}/hdiff
%attr(755,root,root) %{_bindir}/hdp
%attr(755,root,root) %{_bindir}/hrepack
%attr(755,root,root) %{_bindir}/jpeg2hdf
%attr(755,root,root) %{_bindir}/paltohdf
%attr(755,root,root) %{_bindir}/r8tohdf
%attr(755,root,root) %{_bindir}/ristosds
%attr(755,root,root) %{_bindir}/vmake
%attr(755,root,root) %{_bindir}/vshow
%{_mandir}/man1/fp2hdf.1*
%{_mandir}/man1/gif2hdf.1*
%{_mandir}/man1/hdf24to8.1*
%{_mandir}/man1/hdf2gif.1*
%{_mandir}/man1/hdf2jpeg.1*
%{_mandir}/man1/hdf8to24.1*
%{_mandir}/man1/hdfcomp.1*
%{_mandir}/man1/hdfed.1*
%{_mandir}/man1/hdfls.1*
%{_mandir}/man1/hdfncdump.1*
%{_mandir}/man1/hdfncgen.1*
%{_mandir}/man1/hdfpack.1*
%{_mandir}/man1/hdftopal.1*
%{_mandir}/man1/hdftor8.1*
%{_mandir}/man1/hdp.1*
%{_mandir}/man1/jpeg2hdf.1*
%{_mandir}/man1/paltohdf.1*
%{_mandir}/man1/r8tohdf.1*
%{_mandir}/man1/ristosds.1*
%{_mandir}/man1/vmake.1*
%{_mandir}/man1/vshow.1*

%files examples
%defattr(644,root,root,755)
%dir %{_examplesdir}/%{name}-%{version}
%{_examplesdir}/%{name}-%{version}/README
%attr(755,root,root) %{_examplesdir}/%{name}-%{version}/run-all-ex.sh
%dir %{_examplesdir}/%{name}-%{version}/c
%{_examplesdir}/%{name}-%{version}/c/*.c
%{_examplesdir}/%{name}-%{version}/c/*.f
%attr(755,root,root) %{_examplesdir}/%{name}-%{version}/c/run-c-ex.sh
%attr(755,root,root) %{_examplesdir}/%{name}-%{version}/c/run-fortran-ex.sh

%if %{with java}
%files -n java-hdf
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libhdf_java.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libhdf_java.so.0
%attr(755,root,root) %{_libdir}/libhdf_java.so
%{_javadir}/jarhdf-%{version}.jar
%{_javadir}/jarhdf.jar

%files -n java-hdf-javadoc
%defattr(644,root,root,755)
%{_javadocdir}/hdflib
%endif
%changelog
* Fri Nov 13 2020 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/hdf.git;a=log;h=master

* Thu Nov 12 2020 Jakub Bogusz <qboosh@pld-linux.org> c86f28e
- fix _ver_ge usage to work with rpm5

* Thu Nov 12 2020 Jakub Bogusz <qboosh@pld-linux.org> 1caca7c
- added opt patch (don't override optimization)

* Thu Nov 12 2020 Jakub Bogusz <qboosh@pld-linux.org> 0d99c69
- added java-hdf packages (to replace old ones built from hdf-java.spec)

* Thu Nov 12 2020 Jakub Bogusz <qboosh@pld-linux.org> 255f079
- add -fallow-argument-mismatch to fix Fortran build with gcc 10

* Thu Nov 12 2020 Jakub Bogusz <qboosh@pld-linux.org> 29a409d
- shared,szip patches rediffed for fuzz 0

* Thu Nov 12 2020 Jakub Bogusz <qboosh@pld-linux.org> 4f4ee6d
- updated to 4.2.15
- updated link patch
- added tirpc patch; build with libtirpc to support glibc 2.32+

* Thu Dec 27 2018 Jakub Bogusz <qboosh@pld-linux.org> 60b1b52
- updated to 4.2.14

* Thu Aug 16 2018 Jan Rękorajski <baggins@pld-linux.org> 77a5cfd
- rebuild without libjpeg.la
- release 2 (by relup.sh)

* Fri Mar 02 2018 Jakub Bogusz <qboosh@pld-linux.org> d5619bc
- new URLs, updated to 4.2.13

* Thu Aug 04 2016 Jakub Bogusz <qboosh@pld-linux.org> 214c7b4
- updated to 4.2.12

* Sat Mar 07 2015 Jan Rękorajski <baggins@pld-linux.org> 36094dd
- fix building on x32
- rel 2

* Sun Mar 01 2015 Jakub Bogusz <qboosh@pld-linux.org> ce05d7a
- updated to 4.2.12
- removed obsolete format patch

* Sat Dec 06 2014 Jakub Bogusz <qboosh@pld-linux.org> a222389
- added szip patch to fix szip encoder detection; release 2

* Sat Feb 15 2014 Jakub Bogusz <qboosh@pld-linux.org> 9e7bc03
- updated to 4.2.10; package examples

* Sat Mar 02 2013 Jakub Bogusz <qboosh@pld-linux.org> 07e7307
- added format patch, but disable -Werror=format-security anyway because of hdfimport.c

* Sat Mar 02 2013 Jakub Bogusz <qboosh@pld-linux.org> d3698dc
- updated to 4.2.9
- updated link patch

* Sun Aug 26 2012 Jakub Bogusz <qboosh@pld-linux.org> 4a389f8
- updated to 4.2.8
- removed obsolete opt patch

* Thu Feb 16 2012 Jakub Bogusz <qboosh@pld-linux.org> 53352b3
- updated to 4.2.7

* Sun Jun 26 2011 Jakub Bogusz <qboosh@pld-linux.org> 0b9fbb4
- updated to 4.2.6
- removed obsolete jpeg patch
- added CC/FC options processing fix to opt patch
- added link patch (replacing makefile hack)

* Sat Oct 09 2010 Jakub Bogusz <qboosh@pld-linux.org> c21c7ea
- updated to 4.2.5
- updated morearchs patch, added jpeg patch (allow libjpeg>6b)
- epoch 1 (4.2.5 ? 4.2r4)

